namespace NXyn.EmitFSharp

  open System
  open Microsoft.FSharp.Reflection
  open NXyn.EmitFSharp.Common

  module TagStringToUnion =

    let OutputCode (w:System.CodeDom.Compiler.IndentedTextWriter) (t:System.Type) (name_fn:string) (name_activepattern:string) =
      if t.ContainsGenericParameters then failwith "EmitFSharpDispatchUnion.OutputCode: open types unsupported"

      w.WriteLine("let {0} (arg:string) =", name_fn, FSharpTypeName t)
      w.Indent <- w.Indent + 1
      w.WriteLine("match arg.ToLower () with")
      w.Indent <- w.Indent + 1

      let tName = ClippedFSharpTypeName t.Name
      for (uc:UnionCaseInfo) in FSharpType.GetUnionCases t do
        w.WriteLine("| \"{2}\" -> Some({0}{1})", tName + "." + uc.Name, (if uc.GetFields () = [||] then "" else " _"), uc.Name.ToLower ())

      w.WriteLine("| _ -> None")
      w.Indent <- w.Indent - 2

      w.WriteLine("let (|{0}|_|) (x:string) = {1} x", name_activepattern, name_fn)
