module Gen_Champagne_Tree

open NXyn.JSON
open NXyn.Aux.StringMisc

open System.Collections.Generic


let f() = Value.Assoc([| ("a", Value.True); ("b", Value.False) |])

let rec champagneTree_of_size_nonshared(n) = if n <= 0 then f()
                                             else Value.Array([| champagneTree_of_size_nonshared (n-1); champagneTree_of_size_nonshared (n-1) |])

let rec champagneTree_of_size_shared(n) = if n <= 0 then f()
                                          else let sub = champagneTree_of_size_shared (n-1) in Value.Array([|sub;sub|])

let r = new System.Random()

let rec champagneTree_of_size_nonshared_random(n) = if n <= 0 then f()
                                                    else let n0a = n-1-(if r.NextDouble() < 0.5 then 1 else 0)
                                                         let n0b = n-1-(if r.NextDouble() < 0.5 then 1 else 0)
                                                         Value.Array([| champagneTree_of_size_nonshared_random n0a; champagneTree_of_size_nonshared_random n0b |])

let main(args) = let n_option      = args |> Array.tryPick ((|ArgWithValue|_|)    "n" >> (function None -> None | Some(x) -> (|Int32OfString|_|) x))
                 let out_option    = args |> Array.tryPick ((|ArgWithValue|_|)    "out")
                 let random_option = args |> Array.tryPick ((|ArgWithoutValue|_|) "random")
                 let random        = None <> random_option
                 let shared_option = args |> Array.tryPick ((|ArgWithoutValue|_|) "shared")
                 let shared        = None <> shared_option

                 let n    = defaultArg n_option 0
                 let tree = n |> if   random then champagneTree_of_size_nonshared_random
                                 elif shared then champagneTree_of_size_shared
                                             else champagneTree_of_size_nonshared
                 match out_option with None           -> tree.WriteLine()
                                     | Some(filename) -> if filename = "/dev/null" then System.Threading.Thread.Sleep(100000)
                                                         else let f = new System.IO.StreamWriter(filename)
                                                              tree.WriteLine(f)
                                                              f.Close()
main(System.Environment.GetCommandLineArgs())
