(* ==> NXyn.EmitFSharp.Generate_AstIO *)

open System

open Microsoft.FSharp.Reflection

open NXyn.EmitFSharp
open NXyn.EmitFSharp.Common

open X64instr
open Ast

open NXyn.Aux.IOMisc

let rec generate(w:System.IO.TextWriter) = 
  let Item_Id_RelevantTypes = GetRelevantTypes (CollectTypes typeof<Ast.Item>) (typeof<Id>)

  [|
   WriteString_to "(* This source file was generated automatically by module Generate_AstIO --- DO NOT EDIT *)"
   WriteString_to "module AstIO"
   WriteString_to "open System"
   WriteString_to "open X64instr"
   WriteString_to "open Ast"
   WriteString_to "open NXyn.Aux.ListMisc"
//   WriteString_to AstIO_Prelude

   WriteString_to JSONio.ModulePrelude
   JSONio.WriteUnparser "JSONvalue_of_Program" typeof<Program>
   JSONio.WriteParser   "Program_of_JSONvalue" typeof<Program>

   Fold.OutputCode "Fold_Id_in_Item"   Item_Id_RelevantTypes typeof<Item> typeof<Id> (fun _ -> true) (Some "revCons") None
   Map.OutputCode  "Map_Id_in_Item"    Item_Id_RelevantTypes typeof<Item> typeof<Id> (fun _ -> true)
  |]
  (* following 4 are boilerplate! *)
  |> Array.map (fun f -> async { return(let w = new IO.StringWriter() in f(w); w.ToString()) })
  |> Async.Parallel
  |> Async.RunSynchronously
  |> Array.iter (fun s -> w.WriteLine(s))

and main = let w = new System.IO.StreamWriter("AstIO.fs") in generate(w); w.Close()

(***)

