module NXas_unparse

open System
open System.Collections.Generic

open Ast
open X64instr

open Ast
open AstIO
open MoreAstIO

open NXyn

(***)

(* TBD style *)
let main (sections:Ast.Program) (w:IO.StreamWriter) =
    sections
    |> Array.filter (fun (s_name,_,_) -> not(s_name.Contains("rodata.NXyn")))
    |> Array.iteri (fun i (s_name,s_items,s_array) ->
                      if i > 0 then w.WriteLine("")
                      if s_name.StartsWith(".") && IsNamedSection(s_name.Substring(1)) then Ast.Directive(s_name.Substring(1),s_items) 
                                                                                       else Ast.Directive("section", (Item.Iexpr (Iexpr.Id {Name=s_name})::s_items))
                      |> fun l -> WriteILine_to l w
                      w.WriteLine("")
                      s_array |> Array.iter (fun l -> WriteILine_to l w; w.WriteLine("")))
   
(***)

(* BOILER? *)
match Environment.GetCommandLineArgs() with [| _; log; inFileName; outFileName |] -> use r = new System.IO.StreamReader(inFileName)
                                                                                     let program = AstIO.Program_of_JSONvalue(JSON.Value.Read(r))
                                                                                     r.Close() 
                                                                                     use w = new System.IO.StreamWriter(outFileName)
                                                                                     main program w
                                                                                     w.Close()
                                           | _ -> eprintfn "usage: asmGetSections.exe <input.S> <output.S>"; exit 1
